HDU 1054 Strategic Game(树形DP)

来源:互联网 发布:化学分子式软件 编辑:程序博客网 时间:2024/04/30 09:29
Problem Description
Bob enjoys playing computer games, especially strategic games, but sometimes he cannot find the solution fast enough and then he is very sad. Now he has the following problem. He must defend a medieval city, the roads of which form a tree. He has to put the minimum number of soldiers on the nodes so that they can observe all the edges. Can you help him?

Your program should find the minimum number of soldiers that Bob has to put for a given tree.

The input file contains several data sets in text format. Each data set represents a tree with the following description:

the number of nodes
the description of each node in the following format
node_identifier:(number_of_roads) node_identifier1 node_identifier2 ... node_identifier
or
node_identifier:(0)

The node identifiers are integer numbers between 0 and n-1, for n nodes (0 < n <= 1500). Every edge appears only once in the input data.

For example for the tree: 

 

the solution is one soldier ( at the node 1).

The output should be printed on the standard output. For each given input data set, print one integer number in a single line that gives the result (the minimum number of soldiers). An example is given in the following table:
 

Sample Input
40:(1) 11:(2) 2 32:(0)3:(0)53:(3) 1 4 21:(1) 02:(0)0:(0)4:(0)
 

Sample Output
12

一般的树形DP;

#include<iostream>#include<cstdio>#include<cstring>#include<algorithm>#include<limits.h>#include<vector>typedef long long LL;using namespace std;#define REPF( i , a , b ) for ( int i = a ; i <= b ; ++ i )#define REP( i , n ) for ( int i = 0 ; i < n ; ++ i )#define CLEAR( a , x ) memset ( a , x , sizeof a )vector<int>v[1500];int vis[1500];int dp[1500][2];int n,m;void dfs(int x){    if(vis[x])  return ;    vis[x]=1;    dp[x][1]=1;    dp[x][0]=0;    for(int i=0;i<v[x].size();i++)    {        if(!vis[v[x][i]])        {            dfs(v[x][i]);            dp[x][0]+=dp[v[x][i]][1];            dp[x][1]+=min(dp[v[x][i]][1],dp[v[x][i]][0]);        }    }}int main(){    int x,y,temp;    while(~scanf("%d",&n))    {        REP(i,n)            v[i].clear();        REPF(i,1,n)        {           scanf("%d:(%d)",&x,&y);           while(y--)           {               scanf("%d",&temp);               v[x].push_back(temp);               v[temp].push_back(x);           }        }        CLEAR(vis,0);        dfs(1);//由于是无向图可以在0~n中随变找一个点        printf("%d\n",min(dp[1][1],dp[1][0]));    }    return 0;}


0 0
原创粉丝点击